<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Media Server: core.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Media Server
   &#160;<span id="projectnumber">1.0</span>
   </div>
   <div id="projectbrief">Simple MediaServer with effects and filters</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('core_8hpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">core.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &quot;core/Bin.hpp&quot;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;core/Bus.hpp&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &quot;core/Caps.hpp&quot;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;core/Clock.hpp&quot;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;core/Element.hpp&quot;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;core/ElementFactory.hpp&quot;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;core/Message.hpp&quot;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;core/Object.hpp&quot;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;core/Pad.hpp&quot;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;core/Pipeline.hpp&quot;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;core/Structure.hpp&quot;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacegst.html">gst</a></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;{</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="namespacegst.html#acf05768d6a9f73447eb0d01305e545a9">deinit</a>();</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="namespacegst.html#aa462fc1e16c877fa210e7def887314df">init</a>(<span class="keywordtype">int</span> *argc, <span class="keywordtype">char</span> ***argv);</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="namespacegst.html#a7b6dd2f2c1e303cd5272714da59a335a">init_check</a>(<span class="keywordtype">int</span> *argc, <span class="keywordtype">char</span> ***argv, GError **error);</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160; </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    std::string <a class="code" href="namespacegst.html#a391634471f7bed5364d500bfd3a1da4b">get_main_executable_path</a>();</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    GOptionGroup *<a class="code" href="namespacegst.html#aa983b8b16cb51d904019ed42e750b2c3">init_get_option_group</a>();</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="namespacegst.html#ae273892d35c722b2fbdf66d29ffeec15">is_initialized</a>();</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="namespacegst.html#aacb36d8963dd7b7e2dff8085e625ce22">segtrap_is_enabled</a>();</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160; </div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="namespacegst.html#a229b3856304f0946916d0816283a9ec6">segtrap_set_enabled</a>(<span class="keywordtype">bool</span> enabled);</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div>
<div class="line"><a name="l00098"></a><span class="lineno"><a class="line" href="structgst_1_1Version.html">   98</a></span>&#160;    <span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structgst_1_1Version.html">Version</a></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    {</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        uint32_t major;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        uint32_t minor;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        uint32_t micro;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        uint32_t nano;</div>
<div class="line"><a name="l00104"></a><span class="lineno"><a class="line" href="namespacegst.html#a4257cd54f86937126ac56efe61869234">  104</a></span>&#160;    } <a class="code" href="namespacegst.html#a4257cd54f86937126ac56efe61869234">Version</a>;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160; </div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <a class="code" href="namespacegst.html#a4257cd54f86937126ac56efe61869234">Version</a> <a class="code" href="namespacegst.html#a69bbbf7ee1a6fe955aac6d53a7a61fea">version</a>();</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    std::string <a class="code" href="namespacegst.html#a25c2de3823f0bbc762476ee6b890d6b0">version_string</a>();</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160; </div>
<div class="line"><a name="l00125"></a><span class="lineno"><a class="line" href="namespacegst.html#a2a2b5254b20a1c9709e6b5f392cb8e65">  125</a></span>&#160;    <span class="keyword">typedef</span> <span class="keyword">enum</span></div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    {</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        SHOW_MEDIA_TYPE         = (1 &lt;&lt; 0),</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        SHOW_CAPS_DETAILS       = (1 &lt;&lt; 1),</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        SHOW_NON_DEFAULT_PARAMS = (1 &lt;&lt; 2),</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        SHOW_STATES             = (1 &lt;&lt; 3),</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        SHOW_FULL_PARAMS        = (1 &lt;&lt; 4),</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        SHOW_ALL                = ((1 &lt;&lt; 4) - 1),</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        SHOW_VERBOSE            = (gint)(0xffffffff)</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    } <a class="code" href="namespacegst.html#a2a2b5254b20a1c9709e6b5f392cb8e65">DebugGraphDetails</a>;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160; </div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    std::string <a class="code" href="namespacegst.html#a6edecc4ddcc8013ba748bae4ecc5f185">debug_bin_to_dot_data</a>(Bin &amp;bin, <a class="code" href="namespacegst.html#a2a2b5254b20a1c9709e6b5f392cb8e65">DebugGraphDetails</a> details);</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160; </div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="namespacegst.html#a4dfdd6560339b44860236b0d9abf87e7">debug_bin_to_dot_file</a>(Bin &amp;bin, <a class="code" href="namespacegst.html#a2a2b5254b20a1c9709e6b5f392cb8e65">DebugGraphDetails</a> details, std::string file_name);</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160; </div>
<div class="line"><a name="l00164"></a><span class="lineno"><a class="line" href="namespacegst.html#a0f8e122acf614d8462ae57364386db8a">  164</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="namespacegst.html#a0f8e122acf614d8462ae57364386db8a">gst_debug_bin_to_dot_file_with_ts</a>(<a class="code" href="classgst_1_1Bin.html">Bin</a> &amp;bin, <a class="code" href="namespacegst.html#a2a2b5254b20a1c9709e6b5f392cb8e65">DebugGraphDetails</a> details, std::string file_name);</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160; </div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;} <span class="comment">// namespace gst</span></div>
<div class="ttc" id="aclassgst_1_1Bin_html"><div class="ttname"><a href="classgst_1_1Bin.html">gst::Bin</a></div><div class="ttdef"><b>Definition:</b> Bin.hpp:9</div></div>
<div class="ttc" id="anamespacegst_html"><div class="ttname"><a href="namespacegst.html">gst</a></div><div class="ttdoc">Namespace for all GStreamer an GLib Wrappers.</div><div class="ttdef"><b>Definition:</b> Bin.hpp:7</div></div>
<div class="ttc" id="anamespacegst_html_a0f8e122acf614d8462ae57364386db8a"><div class="ttname"><a href="namespacegst.html#a0f8e122acf614d8462ae57364386db8a">gst::gst_debug_bin_to_dot_file_with_ts</a></div><div class="ttdeci">void gst_debug_bin_to_dot_file_with_ts(Bin &amp;bin, DebugGraphDetails details, std::string file_name)</div><div class="ttdoc">This works like.</div></div>
<div class="ttc" id="anamespacegst_html_a229b3856304f0946916d0816283a9ec6"><div class="ttname"><a href="namespacegst.html#a229b3856304f0946916d0816283a9ec6">gst::segtrap_set_enabled</a></div><div class="ttdeci">void segtrap_set_enabled(bool enabled)</div><div class="ttdoc">Applications might want to disable/enable the SIGSEGV handling of the GStreamer core....</div><div class="ttdef"><b>Definition:</b> core.cpp:43</div></div>
<div class="ttc" id="anamespacegst_html_a25c2de3823f0bbc762476ee6b890d6b0"><div class="ttname"><a href="namespacegst.html#a25c2de3823f0bbc762476ee6b890d6b0">gst::version_string</a></div><div class="ttdeci">std::string version_string()</div><div class="ttdoc">This function returns a string that is useful for describing this version of GStreamer to the outside...</div><div class="ttdef"><b>Definition:</b> core.cpp:55</div></div>
<div class="ttc" id="anamespacegst_html_a2a2b5254b20a1c9709e6b5f392cb8e65"><div class="ttname"><a href="namespacegst.html#a2a2b5254b20a1c9709e6b5f392cb8e65">gst::DebugGraphDetails</a></div><div class="ttdeci">DebugGraphDetails</div><div class="ttdoc">Enum containing different modes for dot graph debug output.</div><div class="ttdef"><b>Definition:</b> core.hpp:126</div></div>
<div class="ttc" id="anamespacegst_html_a391634471f7bed5364d500bfd3a1da4b"><div class="ttname"><a href="namespacegst.html#a391634471f7bed5364d500bfd3a1da4b">gst::get_main_executable_path</a></div><div class="ttdeci">std::string get_main_executable_path()</div><div class="ttdoc">This helper is mostly helpful for plugins that need to inspect the folder of the main executable to d...</div><div class="ttdef"><b>Definition:</b> core.cpp:23</div></div>
<div class="ttc" id="anamespacegst_html_a4257cd54f86937126ac56efe61869234"><div class="ttname"><a href="namespacegst.html#a4257cd54f86937126ac56efe61869234">gst::Version</a></div><div class="ttdeci">struct gst::Version Version</div><div class="ttdoc">Struct for the version of gstreamer;.</div></div>
<div class="ttc" id="anamespacegst_html_a4dfdd6560339b44860236b0d9abf87e7"><div class="ttname"><a href="namespacegst.html#a4dfdd6560339b44860236b0d9abf87e7">gst::debug_bin_to_dot_file</a></div><div class="ttdeci">void debug_bin_to_dot_file(Bin &amp;bin, DebugGraphDetails details, std::string file_name)</div><div class="ttdoc">To aid debugging applications one can use this method to write out the whole network of gstreamer ele...</div><div class="ttdef"><b>Definition:</b> core.cpp:65</div></div>
<div class="ttc" id="anamespacegst_html_a69bbbf7ee1a6fe955aac6d53a7a61fea"><div class="ttname"><a href="namespacegst.html#a69bbbf7ee1a6fe955aac6d53a7a61fea">gst::version</a></div><div class="ttdeci">Version version()</div><div class="ttdoc">Gets the version number of the GStreamer library.</div><div class="ttdef"><b>Definition:</b> core.cpp:48</div></div>
<div class="ttc" id="anamespacegst_html_a6edecc4ddcc8013ba748bae4ecc5f185"><div class="ttname"><a href="namespacegst.html#a6edecc4ddcc8013ba748bae4ecc5f185">gst::debug_bin_to_dot_data</a></div><div class="ttdeci">std::string debug_bin_to_dot_data(Bin &amp;bin, DebugGraphDetails details)</div><div class="ttdoc">To aid debugging applications one can use this method to obtain the whole network of gstreamer elemen...</div><div class="ttdef"><b>Definition:</b> core.cpp:60</div></div>
<div class="ttc" id="anamespacegst_html_a7b6dd2f2c1e303cd5272714da59a335a"><div class="ttname"><a href="namespacegst.html#a7b6dd2f2c1e303cd5272714da59a335a">gst::init_check</a></div><div class="ttdeci">bool init_check(int *argc, char ***argv, GError **error)</div><div class="ttdoc">Initializes the GStreamer library, setting up internal path lists, registering built-in elements,...</div><div class="ttdef"><b>Definition:</b> core.cpp:18</div></div>
<div class="ttc" id="anamespacegst_html_aa462fc1e16c877fa210e7def887314df"><div class="ttname"><a href="namespacegst.html#aa462fc1e16c877fa210e7def887314df">gst::init</a></div><div class="ttdeci">void init(int *argc, char ***argv)</div><div class="ttdoc">Initializes the GStreamer library, setting up internal path lists, registering built-in elements,...</div><div class="ttdef"><b>Definition:</b> core.cpp:13</div></div>
<div class="ttc" id="anamespacegst_html_aa983b8b16cb51d904019ed42e750b2c3"><div class="ttname"><a href="namespacegst.html#aa983b8b16cb51d904019ed42e750b2c3">gst::init_get_option_group</a></div><div class="ttdeci">GOptionGroup * init_get_option_group()</div><div class="ttdoc">Returns a GOptionGroup with GStreamer's argument specifications. The group is set up to use standard ...</div><div class="ttdef"><b>Definition:</b> core.cpp:28</div></div>
<div class="ttc" id="anamespacegst_html_aacb36d8963dd7b7e2dff8085e625ce22"><div class="ttname"><a href="namespacegst.html#aacb36d8963dd7b7e2dff8085e625ce22">gst::segtrap_is_enabled</a></div><div class="ttdeci">bool segtrap_is_enabled()</div><div class="ttdoc">Some functions in the GStreamer core might install a custom SIGSEGV handler to better catch and repor...</div><div class="ttdef"><b>Definition:</b> core.cpp:38</div></div>
<div class="ttc" id="anamespacegst_html_acf05768d6a9f73447eb0d01305e545a9"><div class="ttname"><a href="namespacegst.html#acf05768d6a9f73447eb0d01305e545a9">gst::deinit</a></div><div class="ttdeci">void deinit()</div><div class="ttdoc">Clean up any resources created by GStreamer in gst::init.</div><div class="ttdef"><b>Definition:</b> core.cpp:8</div></div>
<div class="ttc" id="anamespacegst_html_ae273892d35c722b2fbdf66d29ffeec15"><div class="ttname"><a href="namespacegst.html#ae273892d35c722b2fbdf66d29ffeec15">gst::is_initialized</a></div><div class="ttdeci">bool is_initialized()</div><div class="ttdoc">Use this function to check if GStreamer has been initialized with gst::init or gst::init_check.</div><div class="ttdef"><b>Definition:</b> core.cpp:33</div></div>
<div class="ttc" id="astructgst_1_1Version_html"><div class="ttname"><a href="structgst_1_1Version.html">gst::Version</a></div><div class="ttdoc">Struct for the version of gstreamer;.</div><div class="ttdef"><b>Definition:</b> core.hpp:99</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_a7bb9b575703809b9fbb7ad7f723668f.html">local_app</a></li><li class="navelem"><a class="el" href="dir_81b007610a59bc1f4a5ed448a6168bbb.html">media_framework</a></li><li class="navelem"><a class="el" href="dir_2216667e0452c61c00f98e2752b3a9f2.html">gstreamer-cpp</a></li><li class="navelem"><a class="el" href="dir_4e35b9dc1e034d94f28a0525077dc4f9.html">include</a></li><li class="navelem"><b>core.hpp</b></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
